#include "down.h"

extern class Down downFile;
Down::Down(string url) :
	NetWork(url)
{
}

Down::~Down()
{
}

static void get_filename(string *filename)
{
	if(filename->empty()){
		(*filename) = tmpnam(NULL);
		return;
	}
	(*filename) += "_";
}

static void get_Response_data(Down *down, string *filename, int *filelen, int *startpos, int *ResponCode)
{
	string temp;
	char	buf[512];
	pthread_mutex_lock(&thisattr);

	temp.clear();
	(*ResponCode) = down->get_Response_code();
	down->get_Response_sign("Content-Disposition", &temp);
	if(sscanf(temp.c_str(), "attachment; filename=\"%s\"", buf) != -1) {
		buf[strlen(buf) - 1] = '\0';
		(*filename) = buf;
	} else {
		(*filename) = tmpnam(NULL);
	}
	if(down->get_Response_sign("Content-Length", &temp) != string::npos) {
		sscanf(temp.c_str(), "%d", filelen);
	}
	if(down->get_Response_sign("Content-Range", &temp) != string::npos) {
		sscanf(temp.c_str(), "bytes %d-%d/%d", startpos);
	}
	
	pthread_mutex_unlock(&thisattr);
}

static void down_to_file(int file, int sockfd, int wlen, int filelen, float *update)
{
	int len, tlen;
	char buf[1024];

	while( (len = recv(sockfd, buf, sizeof(buf), 0)) > 0) {
		 buf[len] = '\0';
		do {
			tlen = write(file, buf, len);
			wlen += tlen;
			(*update) = ((float)wlen / (float)filelen) * 100;
			printf("%0.2f%\n", (*update));
		} while((tlen != len) && (len -= tlen));
	}
	close(sockfd);

	cout << "输出" << wlen << endl;
	
}
static void *down_ready(void *arg)
{
	int	file, len, ResponCode, pos, wlen, tlen;
	int	filelen, startpos, flags;
	char	buf[2048] = {'\0'};
	string str, filename;
	DOWNARG *down_info = (DOWNARG*)arg;
	int	sockfd = down_info->sockfd;

	file = len = ResponCode = pos = 0;
	filelen = startpos = flags = wlen = 0;

	str.clear();
	while( (len = recv(sockfd, buf, sizeof(buf), 0)) > 0) {
		buf[len] = '\0';
		str.append(buf, len);

		pthread_mutex_lock(&thisattr);
		pos = down_info->down->data_to_ResponseHead(str);
		pthread_mutex_unlock(&thisattr);
		if(pos == string::npos) {
			continue;
		}else if(pos > 0) {
			break;
		}
	}

	if(len <= 0) {
		delete down_info->td;
		delete down_info;
		pthread_exit((void*)false);
	}

	get_Response_data(down_info->down, &filename, &filelen, &startpos, &ResponCode);
	down_info->td->filename = filename;

	flags = O_RDWR;
	if(!startpos) {
		flags |= O_CREAT;
	}

	while( (file = open(filename.c_str(), flags, S_IRUSR | S_IWUSR)) == -1) {
		get_filename(&filename);
	}
	lseek(file, startpos, SEEK_SET);

	len = str.size() - pos;
	do {
		tlen = write(file, &str[pos], len);
		wlen += tlen;
	} while((tlen != len) && (len -= tlen));	

	down_to_file(file, sockfd, wlen, filelen, &(down_info->td->len));

	delete down_info->td;
	delete down_info;
	pthread_exit((void*)false);	
}
void Down::recv_server(int sockfd)
{
	THREAD	*td = new THREAD;
	m_downlist.push_back(td);


	DOWNARG *arg = new DOWNARG;
	arg->td = td;
	arg->down = this;
	arg->sockfd = sockfd;
	pthread_create(&(td->pid), NULL, down_ready, (void*)arg);
}
